/**
 * Argo Workflows API
 * Argo Workflows is an open source container-native workflow engine for orchestrating parallel jobs on Kubernetes. For more information, please see https://argoproj.github.io/argo-workflows/
 *
 * OpenAPI spec version: VERSION
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { IoK8sApiCoreV1SecretKeySelector } from '../models/IoK8sApiCoreV1SecretKeySelector';
import { HttpFile } from '../http/http';

/**
* GitArtifact is the location of an git artifact
*/
export class IoArgoprojWorkflowV1alpha1GitArtifact {
    /**
    * Branch is the branch to fetch when `SingleBranch` is enabled
    */
    'branch'?: string;
    /**
    * Depth specifies clones/fetches should be shallow and include the given number of commits from the branch tip
    */
    'depth'?: number;
    /**
    * DisableSubmodules disables submodules during git clone
    */
    'disableSubmodules'?: boolean;
    /**
    * Fetch specifies a number of refs that should be fetched before checkout
    */
    'fetch'?: Array<string>;
    /**
    * InsecureIgnoreHostKey disables SSH strict host key checking during git clone
    */
    'insecureIgnoreHostKey'?: boolean;
    'passwordSecret'?: IoK8sApiCoreV1SecretKeySelector;
    /**
    * Repo is the git repository
    */
    'repo': string;
    /**
    * Revision is the git commit, tag, branch to checkout
    */
    'revision'?: string;
    /**
    * SingleBranch enables single branch clone, using the `branch` parameter
    */
    'singleBranch'?: boolean;
    'sshPrivateKeySecret'?: IoK8sApiCoreV1SecretKeySelector;
    'usernameSecret'?: IoK8sApiCoreV1SecretKeySelector;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "branch",
            "baseName": "branch",
            "type": "string",
            "format": ""
        },
        {
            "name": "depth",
            "baseName": "depth",
            "type": "number",
            "format": ""
        },
        {
            "name": "disableSubmodules",
            "baseName": "disableSubmodules",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "fetch",
            "baseName": "fetch",
            "type": "Array<string>",
            "format": ""
        },
        {
            "name": "insecureIgnoreHostKey",
            "baseName": "insecureIgnoreHostKey",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "passwordSecret",
            "baseName": "passwordSecret",
            "type": "IoK8sApiCoreV1SecretKeySelector",
            "format": ""
        },
        {
            "name": "repo",
            "baseName": "repo",
            "type": "string",
            "format": ""
        },
        {
            "name": "revision",
            "baseName": "revision",
            "type": "string",
            "format": ""
        },
        {
            "name": "singleBranch",
            "baseName": "singleBranch",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "sshPrivateKeySecret",
            "baseName": "sshPrivateKeySecret",
            "type": "IoK8sApiCoreV1SecretKeySelector",
            "format": ""
        },
        {
            "name": "usernameSecret",
            "baseName": "usernameSecret",
            "type": "IoK8sApiCoreV1SecretKeySelector",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return IoArgoprojWorkflowV1alpha1GitArtifact.attributeTypeMap;
    }

    public constructor() {
    }
}

